import java.util.*;

public class TrieStringSet implements ISet<String> {
    private TrieNode root;
    private int size;

    public TrieStringSet() {
        this.size = 0;
        this.root = new TrieNode();
    }

    @Override
    public int size() {
        return this.size;
    }

    @Override
    public boolean contains(String elem) {
        return false;
    }

    // A, K, V
    // ^ A's together make up a K (key type)
    // V is just the value type
    // A = Character
    // K = String
    // V = Boolean

    private static class TrieNode {
        public Map<Character, TrieNode> pointers;
        public boolean isPresent;

        public TrieNode() {
            this.pointers = new HashMap<>();
            this.isPresent = false;
        }
    }

    @Override
    public void add(String elem) {
        TrieNode curr = this.root;
        for (char c : elem.toCharArray()) {
            if (curr.pointers.containsKey(c)) {
                curr = curr.pointers.get(c);
            }
            else {
                curr.pointers.put(c, new TrieNode());
                curr = curr.pointers.get(c);
            }
        }
        curr.isPresent = true;
    }

    @Override
    public boolean isEmpty() {
        return false;
    }

    // Collect all of the words in the set into a list
    public List<String> keys() {
        return null;
    }

    // Follow every path and accumulate the "current path" -> list

    @Override
    public Iterator<String> iterator() {
        return null;
    }
}